indexing
	description: "[
	  " The displayable part ('user interface') of our instant messenger application ";
	  
	  Authors: Keno Albrecht and Angela Nicoara
	]"

	date: "$Date: 2005/04/14 14:42:40 $";
	revision: "$Revision: 1.3 $"

class
	UIMENU
	
create
	make_me

feature

	ps_write: MEDIUM_POLLER
	write_comm: MESSAGE_SENDER
	userList: LINKED_LIST[USER]

	make_me (ps_write_: MEDIUM_POLLER; write_comm_: MESSAGE_SENDER; userList_: LINKED_LIST[USER]) is
	do
		ps_write := ps_write_
		write_comm := write_comm_
		userList := userList_
	end

	-- select "send message" or "exit"
	whatToDoMenu is
	local
		selection: INTEGER
		user: USER
		text: STRING
	do
		selection := 0
		from until selection = 2 loop
			selection := 0
			from until (selection = 1) OR (selection = 2) loop
				io.new_line
				io.put_string("1) Send message")
				io.new_line
				io.put_string("2) Exit")
				io.new_line
				io.put_string("Choose (1 or 2) => ")
	
				io.read_integer
				selection := io.last_integer
			end
			if (selection = 1) then
				io.new_line
				user := userMenu
				if (user /= Void) then
					io.new_line
					io.put_string("Enter text to send to " + user.name + " => ")
					io.readline
					text := io.last_string
					
					write_comm.setArguments (user, text)
					ps_write.execute (15, 20000)
				end
			end
		end
	end	

	-- select user to send message to
	userMenu: USER is
	local 
		i: INTEGER
		user: USER
		selectedUser: USER
		selection: INTEGER
	do
		if (userList.count /= 0) then		
			user := Void
			from until user /= Void loop
				from i:=1; userList.start until userList.after loop
					user := userList.item
					io.put_integer (i)
					io.put_string(") " + user.name)
					io.new_line
					userList.forth
					i := i+1
				end				
				io.put_string("Choose (1 to ")
				io.put_integer(userList.count)
				io.put_string(") => ")
				io.read_integer
				selection := io.last_integer
				
				if ((selection > 0) AND (selection <= userList.count)) then
					selectedUser := userList.i_th (selection)
				end
			end
		
			Result := selectedUser
		else
			Result := Void
		end
	end

end -- class UIMENU
